﻿/*  
     This file is part of Emulators Organizer
    A program that organize emulators and roms.
   
    Copyright (C) 2009 - 2012  Ali Hadid, programmed by Ala Hadid

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;
using AHD.Emulators_Organizer.Base;
using AHD.Utilities;

namespace EmulatorsOrganizer.Frms
{
    public partial class Frm_DetectSnapshotsCovers : Form
    {
        string _lastSelected = "";
        EmuConsole console;
        bool isCovers = false;
        bool isPDF = false;
        public Frm_DetectSnapshotsCovers(string title, EmuConsole console, bool IsCovers, bool IsPDF)
        {
            isPDF = IsPDF;
            isCovers = IsCovers;
            this.console = console;
            InitializeComponent();
            this.Text = title;
            if (!IsPDF)
            {
                if (!IsCovers)
                {
                    if (console.ImageDirs == null)
                        console.ImageDirs = new List<string>();
                    foreach (string folder in console.ImageDirs)
                    {
                        if (Directory.Exists(Utilities.GetFullPath(folder)))
                            listBox1.Items.Add(folder);
                    }
                }
                else
                {
                    if (console.CoverDirs == null)
                        console.CoverDirs = new List<string>();
                    foreach (string folder in console.CoverDirs)
                    {
                        if (Directory.Exists(Utilities.GetFullPath(folder)))
                            listBox1.Items.Add(folder);
                    }
                }
            }
            else
            {
                if (console.PDFDirs == null)
                    console.PDFDirs = new List<string>();
                foreach (string folder in console.PDFDirs)
                {
                    if (Directory.Exists(Utilities.GetFullPath(folder)))
                        listBox1.Items.Add(folder);
                }
            }

            if (listBox1.Items.Count > 0)
                _lastSelected = Utilities.GetFullPath(listBox1.Items[listBox1.Items.Count - 1].ToString());
        }
        //start
        private void button1_Click(object sender, EventArgs e)
        {
            //1 get dirs
            if (listBox1.Items.Count == 0)
            {
                MessageBox.Show("There's no folder !!");
                return;
            }
            if (!isPDF)
            {
                if (!isCovers)
                {
                    console.ImageDirs.Clear();
                    foreach (string folder in listBox1.Items)
                    {
                        console.ImageDirs.Add(folder);
                    }
                }
                else
                {
                    console.CoverDirs.Clear();
                    foreach (string folder in listBox1.Items)
                    {
                        console.CoverDirs.Add(folder);
                    }
                }
            }
            else
            {
                console.PDFDirs.Clear();
                foreach (string folder in listBox1.Items)
                {
                    console.PDFDirs.Add(folder);
                }
            }
            progressBar1.Visible = true;
            List<string> dirs = new List<string>();
            foreach (string folder in listBox1.Items)
            {
                dirs.AddRange(Directory.GetFiles(Utilities.GetFullPath(folder), "*", SearchOption.AllDirectories));
            }
            if (!isPDF)
            {
                progressBar1.Maximum = console.Roms.Count;
                string[] Exs = { ".jpg", ".png", ".bmp", ".gif", ".jpeg", ".tiff", ".tif", ".tga" };

                foreach (Rom ro in console.Roms)
                {
                    for (int i = 0; i < dirs.Count; i++)
                    {
                        bool Found = false;
                        string ImageName = Path.GetFileNameWithoutExtension(dirs[i]).ToLower();
                        string RomRealName = Path.GetFileNameWithoutExtension(ro.Path).ToLower();
                        string ImageExtension = Path.GetExtension(dirs[i]).ToLower();
                        if (ImageName.Length >= RomRealName.Length)
                        {
                            foreach (string ext in Exs)
                            {
                                if (ImageExtension.ToLower() == ext)
                                {
                                    if (ImageName.Substring(0, RomRealName.Length).ToLower() == RomRealName.ToLower())
                                    {
                                        if (!isCovers)
                                        {
                                            ro.Snapshots = new List<string>();
                                            ro.Snapshots.Add(dirs[i]);
                                            ro.Snapshots[0] = Utilities.GetDotPath(dirs[i]);
                                        }
                                        else
                                        {
                                            ro.Covers = new List<string>();
                                            ro.Covers.Add(dirs[i]);
                                            ro.Covers[0] = Utilities.GetDotPath(dirs[i]);
                                        }
                                        dirs.RemoveAt(i);
                                        i = -1;
                                        Found = true;
                                        break;
                                    }
                                }
                            }
                        }
                        if (Found)
                            break;
                    }
                    try { progressBar1.Value++; }
                    catch { }
                }
            }
            else//manuals
            {
                progressBar1.Maximum = console.Roms.Count;
                string[] Exs = { ".pdf" };

                foreach (Rom ro in console.Roms)
                {
                    for (int i = 0; i < dirs.Count; i++)
                    {
                        bool Found = false;
                        string ImageName = Path.GetFileNameWithoutExtension(dirs[i]).ToLower();
                        string RomRealName = Path.GetFileNameWithoutExtension(ro.Path).ToLower();
                        string ImageExtension = Path.GetExtension(dirs[i]).ToLower();
                        if (ImageName.Length >= RomRealName.Length)
                        {
                            foreach (string ext in Exs)
                            {
                                if (ImageExtension.ToLower() == ext)
                                {
                                    if (ImageName.Substring(0, RomRealName.Length).ToLower() == RomRealName.ToLower())
                                    {
                                        ro.PDFPath = Utilities.GetDotPath(dirs[i]);
                                        dirs.RemoveAt(i);
                                        i = -1;
                                        Found = true;
                                        break;
                                    }
                                }
                            }
                        }
                        if (Found)
                            break;
                    }
                    try { progressBar1.Value++; }
                    catch { }
                }
            }
            this.DialogResult = System.Windows.Forms.DialogResult.OK;
            Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            Close();
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            FolderBrowserDialog fol = new FolderBrowserDialog();
            fol.SelectedPath = _lastSelected;
            if (fol.ShowDialog(this) == System.Windows.Forms.DialogResult.OK)
            {
                _lastSelected = fol.SelectedPath;
                foreach (string path in listBox1.Items)
                {
                    if (path.ToLower() == Utilities.GetDotPath(fol.SelectedPath).ToLower())
                        return;
                } 
                listBox1.Items.Add(Utilities.GetDotPath(fol.SelectedPath));
            }
        }

        private void linkLabel2_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (listBox1.SelectedIndex >= 0)
                listBox1.Items.RemoveAt(listBox1.SelectedIndex);
        }
    }
}
