﻿/*  
     This file is part of Emulators Organizer
    A program that organize emulators and roms.
   
    Copyright (C) 2009 - 2012  Ali Hadid, programmed by Ala Hadid

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace EmulatorsOrganizer.Frms
{
    public partial class Frm_Extractor : Form
    {
        Thread mainthread = null;
        SevenZip.SevenZipExtractor _Extactor;
        string _Path;
        bool _ExtractFile = false;
        public bool Canceld = false;
        string[] _files;
        string Password;
        string Rompath;
        public Frm_Extractor(string RomPath, string PassWord, string Path, bool ExtractFile, string[] files)
        {
            Password = PassWord;
            Rompath = RomPath;
            _Path = Path;
            _ExtractFile = ExtractFile;
            _files = files;
            InitializeComponent();

            this.Shown += new EventHandler(Frm_Extractor_Shown);
        }

        void _Extactor_FileExtractionFinished(object sender, SevenZip.FileInfoEventArgs e)
        {
            CLOSE();
            //mainthread.Abort();
        }
        void Frm_Extractor_Shown(object sender, EventArgs e)
        {
           // Start();
            PROGRESS();
        }
        delegate void SetValue(int value);
        delegate void normal();
        void SetProgress(int value)
        {
            if (!this.InvokeRequired)
            {
                SetProgress1(value);
            }
            else
            {
                this.Invoke(new SetValue(SetProgress1), new object[] { value });
            }
        }
        void SetProgress1(int value)
        {
            progressBar1.Value = value;
            progressBar1.Refresh();
        }
        void SetStatus(int value)
        {
            if (!this.InvokeRequired)
            {
                SetStatus1(value);
            }
            else
            {
                this.Invoke(new SetValue(SetStatus1), new object[] { value });
            }
        }
        void SetStatus1(int value)
        {
            this.Text = "Extracting " + value + " %";
        }
        void CLOSE()
        {
            if (!this.InvokeRequired)
            { CLOSE1(); }
            else
            { this.Invoke(new normal(CLOSE1)); }
        
        }
        void CLOSE1()
        { Close(); }
        void _Extactor_Extracting(object sender, SevenZip.ProgressEventArgs e)
        {
            SetProgress(e.PercentDone); 
            SetStatus(e.PercentDone);
        }
        void _Extactor_FileExtractionStarted(object sender, SevenZip.FileInfoEventArgs e)
        {
        }

        void PROGRESS()
        {
            if (Password != null)
                _Extactor = new SevenZip.SevenZipExtractor(Rompath, Password);
            else
                _Extactor = new SevenZip.SevenZipExtractor(Rompath);

            _Extactor.FileExtractionFinished += new EventHandler<SevenZip.FileInfoEventArgs>(_Extactor_FileExtractionFinished); ;
            _Extactor.FileExtractionStarted += new EventHandler<SevenZip.FileInfoEventArgs>(_Extactor_FileExtractionStarted);
            _Extactor.Extracting += new EventHandler<SevenZip.ProgressEventArgs>(_Extactor_Extracting);

            if (!_ExtractFile)
                _Extactor.ExtractArchive(_Path);
            else
                _Extactor.ExtractFiles(_Path, _files);

            Application.DoEvents();
        }
        public void Start()
        {
            mainthread = new Thread(new ThreadStart(PROGRESS));
            mainthread.Start();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Canceld = true;
            mainthread.Abort();
            Close();
        }
    }
}
