﻿/*  
     This file is part of Emulators Organizer
    A program that organize emulators and roms.
   
    Copyright (C) 2009 - 2012  Ali Hadid, programmed by Ala Hadid

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace EmulatorsOrganizer.Frms
{
    public partial class Frm_Search : Form
    {
        public List<ListViewItem> items = new List<ListViewItem>();
        public List<ListViewItem> itemsFound = new List<ListViewItem>();
        public bool itemSearched = false;
        public int NextResultIndex
        {
            get
            {
                if (itemsFound.Count == 0)
                    return -1;
                else
                {
                    if (listBox1.SelectedIndex >= 0)
                        return itemsFound[listBox1.SelectedIndex].Index;
                }
                return -1;
            }
        }
        public string FindWhat
        { get { return textBox1.Text; } }
        public void FindNext()
        {
            button1_Click(this, null);
        }
        public Frm_Search(string findWhat, List<ListViewItem> items)
        {
            InitializeComponent();
            textBox1.Text = findWhat;
            this.items = items;
        }
        public event EventHandler FindNextRequest;
        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Length == 0)
            {
                return;
            }

            if (!itemSearched)
            {
                itemsFound.Clear();
                listBox1.Items.Clear();
                int searchelenght = textBox1.Text.Length;
                string searchedtext = textBox1.Text;
                for (int i = 0; i < items.Count; i++)
                {
                    if (items[i].Text.Length < searchelenght)
                        continue;
                    if (!checkBox1.Checked)
                    {
                        for (int j = 0; j < items[i].Text.Length - searchelenght + 1; j++)
                        {
                            string ser = items[i].Text.Substring(j, searchelenght);
                            if (!checkBox2.Checked)
                            {
                                if (ser.ToLower() == textBox1.Text.ToLower())
                                {

                                    listBox1.Items.Add(items[i].Text); itemsFound.Add(items[i]); break;
                                }
                            }
                            else
                            {
                                if (ser == textBox1.Text)
                                { listBox1.Items.Add(items[i].Text); itemsFound.Add(items[i]); break; }
                            }
                        }
                    }
                    else
                    {
                        string[] wordToFind = textBox1.Text.Split(new char[] { ' ' });
                        string[] subtitleTexts = items[i].Text.Split(new char[] { ' ' });
                        int matched = 0;
                        for (int j = 0; j < subtitleTexts.Length; j++)
                        {
                            for (int h = 0; h < wordToFind.Length; h++)
                            {
                                if (!checkBox2.Checked)
                                {
                                    if (subtitleTexts[j].ToLower() == wordToFind[h].ToLower())
                                    {
                                        matched++;
                                        wordToFind[h] = "";
                                        break;
                                    }
                                }
                                else
                                {
                                    if (subtitleTexts[j] == wordToFind[h])
                                    {
                                        wordToFind[h] = "";
                                        matched++; break;
                                    }
                                }
                            }
                        }
                        if (matched >= wordToFind.Length)
                        {
                            listBox1.Items.Add(items[i].Text); itemsFound.Add(items[i]); 
                        }
                    }
                }
                if (listBox1.Items.Count > 0)
                    listBox1.SelectedIndex = 0;
                itemSearched = true;
            }
            else
            {
                try 
                {
                    listBox1.SelectedIndex++;
                }
                catch
                {
                    if (listBox1.Items.Count > 0)
                        listBox1.SelectedIndex = 0;
                }
            }
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (FindNextRequest != null)
                FindNextRequest(this, null);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            itemSearched = false; button1_Click(this, null);
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            itemSearched = false;
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            itemSearched = false;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
