﻿/*  
     This file is part of Emulators Organizer
    A program that organize emulators and roms.
   
    Copyright (C) 2009 - 2012  Ali Hadid, programmed by Ala Hadid

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
using System;
using System.Collections.Generic;
using System.Text;

namespace ISO9660.PrimitiveTypes
{
    internal class PathTableRecord
    {
        public byte Length;					// N, the identifier length (or 1 for the root directory)

        public byte ExtendedLength = 0;		// 0 [number of sectors in extended attribute record]

        public UInt32 ExtentLocation;		/* number of the first sector in the directory, as a
	                                         * double word
	                                         */

        public UInt16 ParentNumber;			/* number of record for parent directory (or 1 for the root
	                                         * directory), as a word; the first record is number 1,
	                                         * the second record is number 2, etc.
	                                         */

        public byte[] Identifier;			// identifier (or 0 for the root directory)

        // One record must have even number of bytes.
    }
}
